/**
 * @copyright 2015 Tridium, Inc. All Rights Reserved.
 * @author Danesh Kamal
 */

/**
 * @module nmodule/alarm/rc/db/AlarmFacetColumn
 * @private
 */
define(['baja!',
    'jquery',
    'underscore',
    'lex!baja',
    'Promise',
    'nmodule/webEditors/rc/fe/fe',
    'nmodule/webEditors/rc/wb/table/model/Column'],
  function (baja, $, _, lexs, Promise, fe, Column) {
    "use strict";

    var FORMATTED_KEYS = ['msgText'];

    var AlarmFacetColumn = function (name, params) {
      Column.apply(this, [name, params]);
    };

    AlarmFacetColumn.prototype = Object.create(Column.prototype);
    AlarmFacetColumn.prototype.constructor = AlarmFacetColumn;

    AlarmFacetColumn.prototype.buildCell = function (row, dom) {
      var key                = this.$name,
          value              = row.getSubject().get('alarmData').get(key) || '',
          requiresFormatting = _.contains(FORMATTED_KEYS, key);

      return Promise.resolve(value &&
        requiresFormatting &&
        baja.Format.format({object: row.getSubject(), pattern: value})
      ).then(function (str) {
          dom.text(str || '');
        });
    };

    return AlarmFacetColumn;
  });
