/**
 * @copyright 2015 Tridium, Inc. All Rights Reserved.
 * @author Logan Byam
 */

/*jslint white: true, nomen: true, node: true, todo: true */

var requirejs = require('requirejs'),
    extend = require('node.extend');

/**
 * A function that configures RequireJS for running BajaScript inside node.
 * @private
 * @module env/require-node-config
 * @param {Object} config RequireJS configuration info
 * @param {Object} config.connectParams connection info BajaScript will use
 * to connect to the station
 */
module.exports = function (config) {
  'use strict';
  
  extend(true, config, {
    nodeRequire: require,
    baseUrl: __dirname + '/..',
    paths: {
      'baja': 'plugin/baja',
      'ord': 'plugin/node-ord'
    },
    moduledev: {
      filePath: 'd:\\niagara\\r38\\rel\\lib\\moduledev.properties',
      alwaysReload: false
    },
    //TODO: can we move baja up a level?
    config: {
      baja: {
        start: {
          connectParams: config.connectParams
        }
      }
    }
  });
  
  requirejs.config(config);
  
  return requirejs;
};
