var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

/**
 * @license Copyright 2012, Tridium, Inc. All Rights Reserved.
 */

/**
 * @fileOverview BackButton class
 * 
 * @author Gareth Johnson
 * @version 0.0.2.0
 */

/**
 * @private
 * @module mobile/px/widgets/BackButton
 */
define(['baja!', 'lex!mobile', 'Promise', 'mobile/px/util.px.mobile', 'mobile/px/widgets/Button'], function (baja, lexs, Promise, pxUtilMobile, Button) {

  "use strict";

  var saveModifyQuestion = pxUtilMobile.saveModifyQuestion,
      _lexs = _slicedToArray(lexs, 1),
      mobileLex = _lexs[0];


  return baja.registerType('kitPx:BackButton', function () {

    /**
     * The Widget that represents Niagara's 'kitPx:BackButton' Type.
     *
     * @private
     * @class
     * @alias module:mobile/px/widgets/BackButton
     * @extends module:mobile/px/widgets/Button
     */
    var BackButton = function BackButton() {
      Button.apply(this, arguments);
    };
    BackButton.prototype = Object.create(Button.prototype);
    BackButton.prototype.constructor = BackButton;

    /**
     * Called when the widget is first loaded.
     */
    BackButton.prototype.load = function () {
      Button.prototype.load.apply(this, arguments);

      // a ForwardButton is always enabled and always has text "Forward".
      // WB only enables it if there is history to move back to; for
      // security, JS will not allow us see this info, so always enable and it
      // will just do nothing if there is no backward history
      this.setEnabled(true);
      this.setText(mobileLex.get('back'));
    };

    /**
     * Handle a UI Widget event.
     */
    BackButton.prototype.doHandleEvent = function (eventName) {
      saveModifyQuestion(this, function () {
        return window.history.back();
      });

      // Return true so the event doesn't filter down to the bindings
      return true;
    };

    return BackButton;
  });
});
