/*jshint evil: true */

/**
 * @license Copyright 2012, Tridium, Inc. All Rights Reserved.
 */

/**
 * @fileOverview MobileJavaScriptButton class
 * 
 * @author Gareth Johnson
 * @version 0.0.2.0
 */
define(['baja!', 'mobile/px/widgets/Button'], function (baja, Button) {

  "use strict";

  return baja.registerType("mobile:MobileJavaScriptButton", function () {

    /**
     * @class MobileJavaScriptButton
     *
     * The Widget that represents Niagara's 'mobile:BMobileJavaScriptButton' Type.
     *
     * @name MobileJavaScriptButton
     * @extends Button
     */
    function MobileJavaScriptButton() {
      baja.callSuper(MobileJavaScriptButton, this, arguments);
    }

    baja.subclass(MobileJavaScriptButton, Button);

    /**
     * Handle a UI Widget event.
     */
    MobileJavaScriptButton.prototype.doHandleEvent = function (eventName) {
      var that = this;

      try {
        new Function('widget', that.getJavaScript()).call(that, that);
      } catch (err) {
        baja.error(err);
      }

      // Return true so the event doesn't filter down to the bindings
      return true;
    };

    return MobileJavaScriptButton;
  });
});
