var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @copyright 2016 Tridium, Inc. All Rights Reserved.
 * @author Danesh Kamal
 */

/**
 * CompositeEditor
 * @module nmodule/webEditors/rc/wb/composite/CompositeEditor
 * @private
 */
define([
//Core
'baja!', 'baja!baja:CompositeAction,baja:CompositeTopic', 'lex!workbench', 'log!nmodule.webEditors.rc.wb.composite.CompositeEditor', 'bajaux/Widget', 'jquery', 'underscore', 'Promise', 'bajaux/events',

//webEditors
'nmodule/webEditors/rc/fe/fe', 'nmodule/webEditors/rc/fe/baja/BaseEditor',

//Tree
'nmodule/webEditors/rc/wb/tree/NavTree', 'nmodule/webEditors/rc/wb/tree/TreeNode', 'nmodule/webEditors/rc/wb/tree/BajaComplexTreeNode',

//Table
'nmodule/webEditors/rc/wb/table/Table', 'nmodule/webEditors/rc/wb/table/model/TableModel', 'nmodule/webEditors/rc/wb/table/model/Column', 'nmodule/webEditors/rc/wb/table/model/Row', 'nmodule/webEditors/rc/fe/baja/IconEditor',

//Commands
'bajaux/util/CommandButton', 'bajaux/commands/CommandGroup', 'bajaux/util/CommandButtonGroup', 'nmodule/webEditors/rc/wb/composite/commands/AddCommand', 'nmodule/webEditors/rc/wb/composite/commands/MoveDownCommand', 'nmodule/webEditors/rc/wb/composite/commands/MoveUpCommand', 'nmodule/webEditors/rc/wb/composite/commands/RemoveCommand', 'nmodule/webEditors/rc/wb/composite/commands/RenameCommand', 'nmodule/webEditors/rc/wb/composite/commands/ReverseCommand', 'nmodule/webEditors/rc/wb/composite/commands/CompositeCommand',

//Template
'hbs!nmodule/webEditors/rc/wb/composite/template/CompositeEditor',

//Styles
'css!nmodule/js/rc/jquery/split-pane/split-pane', 'css!nmodule/webEditors/rc/wb/composite/style/CompositeEditor',

//Split-pane plugin
'nmodule/js/rc/jquery/split-pane/split-pane'], function (baja, types, lexs, log, Widget, $, _, Promise, events, fe, BaseEditor, NavTree, TreeNode, BajaComplexTreeNode, Table, TableModel, Column, Row, IconEditor, CommandButton, CommandGroup, CommandButtonGroup, AddCommand, MoveDownCommand, MoveUpCommand, RemoveCommand, RenameCommand, ReverseCommand, CompositeCommand, template) {

  'use strict';

  var lex = lexs[0],
      makeRow = AddCommand.$makeTableRow,
      logError = log.severe.bind(log),
      IN = 0,
      OUT = 1,
      DELETE_KEY = 46,
      ENTER_KEY = 13,
      HEADER_TITLE = lex.get("compositeEditor.title"),
      HEADER_SUBTITLE = lex.get("compositeEditor.subtitle"),
      HEADER_ICON = "/module/icons/x32/composite.png",
      IN_TEXT = lex.get("compositeEditor.in"),
      OUT_TEXT = lex.get("compositeEditor.out"),
      IN_ICON = baja.Icon.make('module://icons/x16/arrowLeft.png'),
      OUT_ICON = baja.Icon.make('module://icons/x16/arrowRight.png'),
      TEMPLATE_CONTEXT = { title: HEADER_TITLE, subtitle: HEADER_SUBTITLE, icon: HEADER_ICON },


  //classes/selectors
  ADD_CMD_SELECTOR = '.add-command',
      TREE_SELECTOR = '.composite-tree',
      TABLE_SELECTOR = '.composite-table',
      CMD_GROUP_SELECTOR = '.table-command-group',
      SPLIT_PANE_SELECTOR = '.split-pane',
      DIR_COL_CLASS = 'directionColumn',
      DIR_COL_SELECTOR = '.' + DIR_COL_CLASS,
      SLOT_ICON_CLASS = 'slotIcon',
      SLOT_DIRECTION_CLASS = 'slotDirection',


  //table columns
  DIRECTION_COLUMN = new Column(lex.get("compositeEditor.dir")),
      SLOT_COLUMN = new Column(lex.get("compositeEditor.slot")),
      ORD_COLUMN = new Column(lex.get("compositeEditor.ord"));

  /////////////////////////////////////////////////////////////////
  //Commands
  ///////////////////////////////////////////////////////////////////////
  function initCommands(editor) {
    return Promise.join(initAddCommand(editor), initTableCommands(editor));
  }

  function initAddCommand(editor) {
    return fe.buildFor({
      dom: editor.jq().find(ADD_CMD_SELECTOR),
      type: CommandButton,
      value: new AddCommand(editor),
      formFactor: 'mini'
    });
  }

  function initTableCommands(editor) {
    return fe.buildFor({
      dom: editor.jq().find(CMD_GROUP_SELECTOR),
      type: CommandButtonGroup,
      value: initTableCommandGroup(editor),
      properties: { toolbar: true },
      formFactor: 'mini'
    });
  }

  function initTableCommandGroup(editor) {
    return new CommandGroup({
      commands: [new ReverseCommand(editor), new RenameCommand(editor), new RemoveCommand(editor), new MoveUpCommand(editor), new MoveDownCommand(editor)]
    });
  }

  //////////////////////////////////////////////////////////////////////
  //Tree
  ///////////////////////////////////////////////////////////////////////
  function initTree(editor) {
    return fe.makeFor({ //only initialize but don't load the tree
      type: NavTree,
      value: new TreeNode(''),
      formFactor: 'mini'
    }).then(function (tree) {
      return tree.initialize(editor.$getTreeDom()).return(tree);
    }).then(function (tree) {
      return armTreeEvents(tree, editor);
    });
  }

  function armTreeEvents(tree, editor) {
    var ACTIVATED_EVENT = NavTree.ACTIVATED_EVENT,
        SELECTED_EVENT = NavTree.SELECTED_EVENT,
        DESELECTED_EVENT = NavTree.DESELECTED_EVENT;


    tree.jq().on(ACTIVATED_EVENT, function () {
      //invoke Add command on double click
      var addCmd = editor.$getAddCommand();

      if (addCmd.isEnabled()) {
        addCmd.invoke().catch(logError);
      }
    }).on(SELECTED_EVENT + ' ' + DESELECTED_EVENT, function () {
      //Enable/Disable the Add command on selection/deselection
      var addCmd = editor.$getAddCommand(),
          selectedNodes = editor.$getTree().getSelectedNodes(),
          addCmdEnabled = _(selectedNodes).every(treeNodeValid);

      addCmd.setEnabled(addCmdEnabled);
    }).on('selectstart', function () {
      return false;
    }); //disable highlighting in IE
  }

  function treeNodeValid(node) {
    var value = node && node.value();
    if (!value) {
      //the node may be a simple, action or topic
      var parent = node.getParent(),
          _value = parent && parent.value();
      return _value && _.isFunction(_value.getSlotPath); //node is valid if parent is defined
    } else {
      //consider the node valid only if it's not a Component
      return !value.getType().isComponent();
    }
  }

  function loadTree(editor, component) {
    var root = new BajaComplexTreeNode(component),
        tree = editor.$getTree();

    function removableKids(kid) {
      var value = kid.value();
      return !baja.hasType(value, 'baja:Component');
    }

    return root.getKids().then(function (kids) {
      return Promise.map(_(kids).filter(removableKids), function (kid) {
        return root.remove(kid);
      });
    }).then(function () {
      return tree.load(root);
    });
  }

  ///////////////////////////////////////////////////////////////////////
  //Table
  ///////////////////////////////////////////////////////////////////////

  function initTable(editor) {

    configureColumnOverrides(editor);

    return fe.buildFor({
      dom: editor.jq().find(TABLE_SELECTOR),
      type: Table,
      value: new TableModel({ columns: [DIRECTION_COLUMN, SLOT_COLUMN, ORD_COLUMN] }),
      formFactor: 'mini',
      initializeParams: { finishBuildingRow: updateRowClass }
    }).then(function (table) {
      return armTableEvents(table, editor);
    });
  }

  function configureColumnOverrides(editor) {

    //Direction column
    DIRECTION_COLUMN.buildCell = function (row, dom) {
      var slot = row.getSubject(),
          icon = slot.dir === IN ? IN_ICON : OUT_ICON,
          dir = slot.dir === IN ? IN_TEXT : OUT_TEXT;

      dom.addClass(DIR_COL_CLASS);

      return fe.buildFor({
        dom: $("<span/>").appendTo(dom).addClass(SLOT_ICON_CLASS),
        type: IconEditor,
        value: icon
      }).then(function () {
        return dom.append($('<span>' + dir + '</span>').addClass(SLOT_DIRECTION_CLASS));
      });
    };

    //Slot column
    SLOT_COLUMN.getValueFor = function (row) {
      return row.getSubject().name;
    };

    //Ord column
    ORD_COLUMN.getValueFor = function (row) {
      var composite = editor.value(),
          subject = row.getSubject(),
          slotPathPrefix = composite.getSlotPath().toString(),
          slotPath = subject.ord + '/' + subject.slot;

      return slotPath.substring(slotPathPrefix.length + 1);
    };
  }

  function updateRowClass(row, dom) {
    var type = row.getSubject().type,
        isAction = type && type.isAction && type.isAction(),
        isTopic = type && type.isTopic && type.isTopic();

    //add the corresponding color class to the dom row
    return dom.removeClass('propertyRow actionRow topicRow').addClass(isAction ? 'actionRow' : isTopic ? 'topicRow' : 'propertyRow');
  }

  function armTableEvents(table, editor) {
    var cmds = editor.$getTableCommandGroup().getChildren(),
        _cmds = _slicedToArray(cmds, 3),
        reverseCmd = _cmds[0],
        renameCmd = _cmds[1],
        removeCmd = _cmds[2];

    //TableController events
    table.jq().keyup(function (event) {
      if (event.which === DELETE_KEY && removeCmd.isEnabled()) {
        removeCmd.invoke();
      }

      if (event.which === ENTER_KEY && renameCmd.isEnabled()) {
        renameCmd.invoke();
        return false;
      }
    }).on('dblclick', 'tr', function () {
      if (renameCmd.isEnabled()) {
        renameCmd.invoke();
      }
    }).on('dblclick', DIR_COL_SELECTOR, function (event) {
      if (reverseCmd.isEnabled()) {
        reverseCmd.invoke();
      }
      event.stopPropagation(); //prevent 'tr' dblclick handler from handling this event
    }).on('selectstart', function () {
      return false;
    }); //disable highlighting in IE

    //TableSelection events
    var model = table.value(),
        selection = table.$getSelection();

    selection.on('changed', function () {

      _(cmds).each(function (cmd) {
        cmd.setEnabled(!selection.isEmpty());
      });

      //disable the Reverse command if the table selection includes rows with a
      //readonly slot or if both directions are represented
      if (!selection.isEmpty()) {
        var rows = model.getRows(),
            selectedRows = selection.getSelectedElements(rows),
            enabled = reverseCmd.isEnabled();

        for (var i = 0; i < selectedRows.length; i++) {
          var slot = selectedRows[i].getSubject();
          if (slot.readonly) {
            enabled = false;
            break;
          }

          for (var j = 0; j < rows.length; j++) {
            var temp = rows[j].getSubject();
            if (temp.ord + temp.slot === slot.ord + slot.slot && temp.name !== slot.name) {
              enabled = false;
              break;
            }
          }
        }

        reverseCmd.setEnabled(enabled);
      }
    });
  }

  function loadTable(editor, composite) {
    var model = editor.$getTable().value();

    return Promise.join(getLinkRows(model, composite), getKnobRows(model, composite), function (linkRows, knobRows) {
      return model.insertRows(linkRows.concat(knobRows)).then(function () {
        return sortRows(composite, model);
      });
    });
  }

  /**
   * Returns the list of rows corresponding to the composite's links
   * @private
   * @param model TableModel
   * @param composite
   * @returns {Array.<module:nmodule/webEditors/rc/wb/table/model/Row>} The array of link rows
   */
  function getLinkRows(model, composite) {

    var links = composite.getLinks(); //get incoming links from child components

    return Promise.map(links, function (link) {

      return link.getSourceOrd().resolve({ base: composite, lease: true }).then(function (ordTarget) {

        var src = ordTarget.getComponent(),
            srcSlotPath = src.getSlotPath().toString(),
            compositeSlotPath = composite.getSlotPath().toString();

        //process only if the composite is on the source's slot path (implying the source is a descendant)
        if (srcSlotPath.indexOf(compositeSlotPath) === 0 && srcSlotPath !== compositeSlotPath) {

          var srcSlotName = link.getSourceSlotName(),
              srcSlot = src.getSlot(srcSlotName),
              srcFlags = src.getFlags(srcSlot),
              srcSlotReadonly = srcSlot.isTopic() || srcFlags & baja.Flags.READONLY === baja.Flags.READONLY,
              targetSlotName = link.getTargetSlotName(),
              targetSlot = composite.getSlot(targetSlotName);

          if (!targetSlot) {
            return composite.remove(link.getName()).return(null);
          } else {
            return makeRow({
              dir: OUT, //Outgoing link from the perspective of the sub-component
              name: targetSlotName,
              ord: srcSlotPath,
              slot: srcSlotName,
              type: composite.get(targetSlot).getType(),
              readonly: srcSlotReadonly,
              backup: true,
              flags: composite.getFlags(targetSlot)
            });
          }
        } else {
          return null;
        }
      });
    }).then(_.compact);
  }

  /**
   * Returns the list of rows corresponding to the composite's knobs
   * @private
   * @param model TableModel
   * @param composite
   * @returns {Array.<module:nmodule/webEditors/rc/wb/table/model/Row>} The array of knob rows
   */
  function getKnobRows(model, composite) {
    var knobs = composite.getKnobs();

    return Promise.map(knobs, function (knob) {

      return knob.getTargetOrd().resolve({ base: composite, lease: true }).then(function (ordTarget) {

        var target = ordTarget.getComponent(),
            targetSlotPath = target.getSlotPath().toString(),
            compositeSlotPath = composite.getSlotPath().toString();

        if (targetSlotPath.indexOf(compositeSlotPath) === 0 && targetSlotPath !== compositeSlotPath) {

          var sourceSlotName = knob.getSourceSlotName(),
              targetSlotName = knob.getTargetSlotName(),
              sourceSlot = composite.getSlot(sourceSlotName);

          if (!sourceSlot) {
            //delete the corresponding links on the target
            return Promise.map(target.getLinks(targetSlotName), function (link) {
              return target.remove(link.getName());
            }).return(null);
          } else {
            return makeRow({
              dir: IN, //Incoming link from the perspective of the sub-component
              name: sourceSlotName,
              ord: targetSlotPath,
              slot: targetSlotName,
              type: composite.get(sourceSlot).getType(),
              readonly: false,
              backup: true,
              flags: composite.getFlags(sourceSlot)
            });
          }
        } else {
          return null;
        }
      });
    }).then(_.compact);
  }

  /**
   * Sort the loaded slots so that they appear in the correct order
   * @param composite
   * @param model
   */
  function sortRows(composite, model) {
    var names = _(composite.getSlots().toArray()).map(function (slot) {
      return slot.getName();
    });
    model.sort(function (r1, r2) {
      return _.indexOf(names, r1.getSubject().name) - _.indexOf(names, r2.getSubject().name);
    });
  }

  /**
   * CompositeEditor
   *
   * @class CompositeEditor
   * @extends module:nmodule/webEditors/rc/fe/baja/BaseEditor
   * @alias module:nmodule/webEditors/rc/composite/CompositeEditor
   */

  var CompositeEditor = function (_BaseEditor) {
    _inherits(CompositeEditor, _BaseEditor);

    function CompositeEditor() {
      var _ref;

      _classCallCheck(this, CompositeEditor);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var _this = _possibleConstructorReturn(this, (_ref = CompositeEditor.__proto__ || Object.getPrototypeOf(CompositeEditor)).call.apply(_ref, [this].concat(args)));

      _this.$compositeCmd = new CompositeCommand(_this);
      return _this;
    }

    /**
     * Returns a reference to the NavTree DOM in the editor
     * @private
     * @returns {JQuery} DOM representing NavTree
     */


    _createClass(CompositeEditor, [{
      key: '$getTreeDom',
      value: function $getTreeDom() {
        return this.jq().find(TREE_SELECTOR);
      }

      /**
       * Returns a reference to the NavTree for selecting slots to composite
       * @private
       * @returns {module:nmodule/webEditors/rc/wb/tree/NavTree} NavTree editor
       */

    }, {
      key: '$getTree',
      value: function $getTree() {
        return this.$getTreeDom().data('widget');
      }

      /**
       * Returns a reference to the Table for displaying composited slots
       * @private
       * @returns {module:nmodule/webEditors/rc/wb/table/Table} Table editor
       */

    }, {
      key: '$getTable',
      value: function $getTable() {
        return this.jq().find(TABLE_SELECTOR).data('widget');
      }

      /**
       * Returns a reference to the TableModel for the display Table widget
       * @private
       * @returns {module:nmodule/webEditors/rc/wb/table/model/TableModel} TableModel
       */

    }, {
      key: '$getTableModel',
      value: function $getTableModel() {
        return this.$getTable().value();
      }

      /**
       * Returns a reference to the CommandButton editor for the AddCommand
       * @private
       * @returns {module:bajaux/util/CommandButton} CommandButton
       */

    }, {
      key: '$getAddCommandButton',
      value: function $getAddCommandButton() {
        return this.jq().find(ADD_CMD_SELECTOR).data('widget');
      }

      /**
       * Returns a reference to the AddCommand for adding selected slots from the tree to the table
       * @private
       * @returns {module:nmodule/webEditors/rc/wb/composite/commands/AddCommand} AddCommand
       */

    }, {
      key: '$getAddCommand',
      value: function $getAddCommand() {
        return this.$getAddCommandButton().value();
      }

      /**
       * Returns a reference to the CommandButtonGroup editor for the table commands
       * @private
       * @returns {module:bajaux/util/CommandButtonGroup} CommandButtonGroup
       */

    }, {
      key: '$getTableCommandButtonGroup',
      value: function $getTableCommandButtonGroup() {
        // noinspection JSValidateTypes
        return Widget.in(this.jq().find(CMD_GROUP_SELECTOR));
      }

      /**
       * Returns a reference to the CommandGroup for the table commands
       * @private
       * @returns {module:bajaux/commands/CommandGroup} CommandGroup
       */

    }, {
      key: '$getTableCommandGroup',
      value: function $getTableCommandGroup() {
        return this.$getTableCommandButtonGroup().value();
      }

      /**
       * Returns a reference to the CompositeCommand for compositing slots
       * @private
       * @returns {module:nmodule/webEditors/rc/wb/composite/commands/CompositeCommand} CompositeCommand
       */

    }, {
      key: '$getCompositeCommand',
      value: function $getCompositeCommand() {
        return this.$compositeCmd;
      }

      /**
       * Initializes the CompositeEditor elements in a split pane
       * @param {JQuery} dom
       * @returns {Promise} Promise resolved when editor elements have been initialized
       */

    }, {
      key: 'doInitialize',
      value: function doInitialize(dom) {

        //initialize template and split pane
        dom.addClass("CompositeEditor").html(template(TEMPLATE_CONTEXT)).find(SPLIT_PANE_SELECTOR).splitPane();

        //init commands, tree, and table
        return Promise.join(initCommands(this), initTree(this), initTable(this));
      }

      /**
       * Loads the component to composite into the editor
       * @param {baja.Component} component to composite
       * @returns {Promise} Promise resolved when component has been loaded
       */

    }, {
      key: 'doLoad',
      value: function doLoad(component) {
        return Promise.join(loadTree(this, component), loadTable(this, component));
      }

      /**
       * Saves the composited slots
       * @param value
       * @param params
       * @returns {Promise} Promise resolved when composite has been saved
       */

    }, {
      key: 'doSave',
      value: function doSave(value, params) {
        return this.$compositeCmd.invoke(params);
      }

      /**
       * Destroys child editors
       * @returns {Promise} Promise resolved when editor has been destroyed
       */

    }, {
      key: 'doDestroy',
      value: function doDestroy() {
        return this.getChildWidgets().destroyAll();
      }
    }]);

    return CompositeEditor;
  }(BaseEditor);

  return CompositeEditor;
});
