function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @copyright 2016 Tridium, Inc. All Rights Reserved.
 * @author Danesh Kamal
 */

/**
 * RemoveCommand
 * @module nmodule/webEditors/rc/wb/composite/commands/RemoveCommand
 * @private
 */

define(['baja!', 'jquery', 'lex!workbench', 'Promise', 'underscore', 'bajaux/commands/Command'], function (baja, $, lexs, Promise, _, Command) {

  'use strict';

  function handleRemove(editor) {
    var table = editor.$getTable(),
        selection = table.$getSelection(),
        model = table.value(),
        rows = selection.getSelectedElements(model.getRows());

    editor.$removed = editor.$removed || [];

    rows = _(rows).map(function (row) {
      var slot = row.getSubject();
      if (slot.backup) {
        editor.$removed.push(_.clone(slot.backup));
      }
      return row;
    });

    return model.removeRows(rows);
  }

  /**
   * RemoveCommand
   *
   * @class MoveDownCommand
   * @extends module:bajaux/commands/Command
   * @alias module:nmodule/webEditors/rc/wb/composite/commands/RemoveCommand
   * @private
   */

  var RemoveCommand = function (_Command) {
    _inherits(RemoveCommand, _Command);

    function RemoveCommand(editor) {
      _classCallCheck(this, RemoveCommand);

      return _possibleConstructorReturn(this, (RemoveCommand.__proto__ || Object.getPrototypeOf(RemoveCommand)).call(this, {
        module: "workbench",
        lex: 'compositeEditor.remove',
        enabled: false,
        func: function func() {
          return handleRemove(editor);
        }
      }));
    }

    return RemoveCommand;
  }(Command);

  return RemoveCommand;
});
