function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @copyright 2016 Tridium, Inc. All Rights Reserved.
 * @author Danesh Kamal
 */

/**
 * ReverseCommand
 * @module nmodule/webEditors/rc/wb/composite/commands/ReverseCommand
 * @private
 */

define(['baja!', 'baja!baja:CompositeAction,baja:CompositeTopic', 'lex!workbench', 'jquery', 'Promise', 'underscore', 'bajaux/commands/Command'], function (baja, types, lexs, $, Promise, _, Command) {

  'use strict';

  var IN = 0,
      OUT = 1,
      COMPOSITE_ACTION = baja.lt('baja:CompositeAction'),
      COMPOSITE_TOPIC = baja.lt('baja:CompositeTopic');

  function handleReverse(editor) {
    var table = editor.$getTable(),
        selection = table.$getSelection(),
        model = table.value(),
        rows = selection.getSelectedElements(model.getRows());

    _(rows).each(function (row) {
      var slot = row.getSubject();

      if (!slot.readonly) {

        slot.dir = slot.dir === IN ? OUT : IN;

        slot.type = slot.type.is(COMPOSITE_ACTION) ? COMPOSITE_TOPIC : slot.type.is(COMPOSITE_TOPIC) ? COMPOSITE_ACTION : slot.type;
      }
    });

    model.emit('rowsChanged', rows);
  }

  /**
   * ReverseCommand
   *
   * @class ReverseCommand
   * @extends module:bajaux/commands/Command
   * @alias module:nmodule/webEditors/rc/wb/composite/commands/ReverseCommand
   * @private
   */

  var ReverseCommand = function (_Command) {
    _inherits(ReverseCommand, _Command);

    function ReverseCommand(editor) {
      _classCallCheck(this, ReverseCommand);

      return _possibleConstructorReturn(this, (ReverseCommand.__proto__ || Object.getPrototypeOf(ReverseCommand)).call(this, {
        module: "workbench",
        lex: 'compositeEditor.reverse',
        enabled: false,
        func: function func() {
          return handleReverse(editor);
        }
      }));
    }

    return ReverseCommand;
  }(Command);

  return ReverseCommand;
});
