/**
 * @copyright 2015 Tridium, Inc. All Rights Reserved.
 * @author Gareth Johnson
 */

/**
 * @private
 * @module nmodule/webEditors/rc/wb/menu/bogFileMenuAgent
 */
define(['bajaux/commands/CommandGroup',
        'nmodule/js/rc/asyncUtils/asyncUtils'], function (
         CommandGroup,
         asyncUtils) {

  'use strict';

  var doRequire = asyncUtils.doRequire;

  return function bogFileMenuAgent(widget, navNode) {
    return doRequire(['nmodule/webEditors/rc/wb/commands/SaveBogFileCommand'])
    .spread(function (
      SaveBogFileCommand) {

      var group = new CommandGroup(),
          saveBogFileCmd = new SaveBogFileCommand(navNode);

      group.add(saveBogFileCmd);

      return navNode.getNavOrd().get()
        .then(function (comp) {

          saveBogFileCmd.setEnabled(comp.getComponentSpace() &&
            !comp.getComponentSpace().isSpaceReadonly());

          return group;
        });
    });
  };
});
