/**
 * @copyright 2015 Tridium, Inc. All Rights Reserved.
 * @author Logan Byam
 */

/**
 * @private
 * @module nmodule/webEditors/rc/wb/menu/navMenuAgent
 */
define(['bajaux/commands/CommandGroup',
        'nmodule/webEditors/rc/wb/menu/menuUtils'], function (
         CommandGroup,
         menuUtils) {

  'use strict';

  var makeViewsGroup = menuUtils.makeViewsGroup;

  var navMenuAgent = function navMenuAgent(widget, comp) {

    return menuUtils.ifAllowedByProfile('viewSelection', function () {
      return makeViewsGroup(comp.getNavOrd());
    })
      .then(function (viewsGroup) {
        return viewsGroup && new CommandGroup({ commands: [ viewsGroup ] });
      });
  };

  return navMenuAgent;
});
